//==============================================================================
// Copyright (C) John-Philip Taylor
// jpt13653903@gmail.com
//==============================================================================
module Delay_Reset(
    input CLK,                 // Input clock signal
    input Button,              // Input RESET signal (external button)
    output reg Reset           // Output RESET signal (delayed)
);
//------------------------------------------------------------------------------
reg tReset;
reg [22:0]Count;               // Assume Count is null on FPGA configuration
//------------------------------------------------------------------------------
always @(posedge CLK) begin    // Activates every clock edge
    tReset <= Button;          // Localise the RESET signal
    if(tReset) begin           // RESET block
        Count <= 0;            // RESET Count to 0
        Reset <= 1'b1;         // RESET the output to 1
    end else if(&Count) begin  // When Count is all ones...
        Reset <= 1'b0;         // Release the output signal
                               // Count remains unchanged  
                               // And do nothing else
    end else begin             // Otherwise...
    Reset <= 1'b1;             // Make sure the output signal is high
    Count <= Count + 1'b1;     // And increment Count
    end
end
//------------------------------------------------------------------------------
endmodule
//------------------------------------------------------------------------------
